-- Test translate_campsite_type_option_option
set client_min_messages to warning;
create extension if not exists pgtap;
reset client_min_messages;

begin;

select plan(13);

set search_path to camper, public;

select has_function('camper', 'translate_campsite_type_option', array['integer', 'text', 'text']);
select function_lang_is('camper', 'translate_campsite_type_option', array['integer', 'text', 'text'], 'sql');
select function_returns('camper', 'translate_campsite_type_option', array['integer', 'text', 'text'], 'void');
select isnt_definer('camper', 'translate_campsite_type_option', array['integer', 'text', 'text']);
select volatility_is('camper', 'translate_campsite_type_option', array['integer', 'text', 'text'], 'volatile');
select function_privs_are('camper', 'translate_campsite_type_option', array['integer', 'text', 'text'], 'guest', array[]::text[]);
select function_privs_are('camper', 'translate_campsite_type_option', array['integer', 'text', 'text'], 'employee', array[]::text[]);
select function_privs_are('camper', 'translate_campsite_type_option', array['integer', 'text', 'text'], 'admin', array['EXECUTE']);
select function_privs_are('camper', 'translate_campsite_type_option', array['integer', 'text', 'text'], 'authenticator', array[]::text[]);


set client_min_messages to warning;
truncate campsite_type_option_i18n cascade;
truncate campsite_type_option cascade;
truncate campsite_type cascade;
truncate media cascade;
truncate media_content cascade;
truncate company cascade;
reset client_min_messages;

insert into company (company_id, business_name, vatin, trade_name, phone, email, web, address, city, province, postal_code, rtc_number, tourist_tax, country_code, currency_code, default_lang_tag)
values (1, 'Company 2', 'XX123', '', '555-555-555', 'a@a', '', '', '', '', '', '', 60, 'ES', 'EUR', 'ca')
;

insert into media_content (media_type, bytes)
values ('image/x-xpixmap', 'static char *s[]={"1 1 1 1","a c #ffffff","a"};')
;

insert into media (media_id, company_id, original_filename, content_hash)
values (2, 1, 'cover2.xpm', sha256('static char *s[]={"1 1 1 1","a c #ffffff","a"};'))
;

insert into campsite_type (campsite_type_id, company_id, slug, media_id, name, description, active, max_campers, bookable_nights)
values (3, 1, '87452b88-b48f-48d3-bb6c-0296de64164e', 2, 'Type A', '<p>A</p>', true, 4, '[1, 7]')
;

insert into campsite_type_option (campsite_type_option_id, campsite_type_id, name, range, per_night)
values (4, 3, 'Option 1', '[1, 1]', true)
     , (5, 3, 'Option 2', '[1, 2]', true)
;

insert into campsite_type_option_i18n (campsite_type_option_id, lang_tag, name)
values (5, 'ca', 'opció2')
;

select lives_ok(
	$$ select translate_campsite_type_option(4, 'ca', 'Opció 1') $$,
	'Should be able to translate the first option'
);

select lives_ok(
	$$ select translate_campsite_type_option(5, 'es', 'Opción 2') $$,
	'Should be able to translate the second option'
);

select lives_ok(
	$$ select translate_campsite_type_option(5, 'ca', 'Opció 2') $$,
	'Should be able to overwrite the catalan translation of the second option'
);

select bag_eq(
	$$ select campsite_type_option_id, lang_tag, name from campsite_type_option_i18n $$,
	$$ values (4, 'ca', 'Opció 1')
	        , (5, 'ca', 'Opció 2')
	        , (5, 'es', 'Opción 2')
	$$,
	'Should have added and updated all translations.'
);


select *
from finish();

rollback;
